﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=\%PROJECT_NAME%.zip

'B4A ide://run?file=%WINDIR%\System32\cmd.exe&Args=/c&Args=start&Args=..\..\B4A\%PROJECT_NAME%.b4a 
'B4i ide://run?file=%WINDIR%\System32\cmd.exe&Args=/c&Args=start&Args=..\..\B4i\%PROJECT_NAME%.b4i 
'B4J ide://run?file=%WINDIR%\System32\cmd.exe&Args=/c&Args=start&Args=..\..\B4J\%PROJECT_NAME%.b4j

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI

#If B4A
	Private IME1 As IME
#End If
	Private SQL1 As SQL
	Public Send As Senden
	Private BSend As B4XView
	Public  tblZaehler As xTableLite
	Private btnHinzufuegen As B4XView
	Private btnAendern, btnLoeschen As B4XView
	Private btnEnde As B4XView
	Private edtZaehlerNummer As B4XView
	Private edtDatum As B4XView
	Private edtZaehlerstand As B4XView
	Private cbxZaehlerNummer, cbxFilterZaehler, cbxFilterDatum As B4XComboBox
	Private Query, Filter As String
	Private DateiPfad, DateiName As String
	Private SelectedRowIndex = -1 As Int
	Private SelectedItemRowID = -1 As Long
	Private B4XBTDevices As B4XComboBox
	Private BtnConnect As B4XView
	Private BtnDisConnect As B4XView
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Send.Initialize
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.AddPage("Send", Send)
	Root.LoadLayout("BTSend")
	DateiName = "Zaehler.db"	
	DateTime.DateFormat = "yyyy.MM.dd"
'Erstellt den 'default' Pfad für die Datenbank
#If B4A
	Private rp As RuntimePermissions
	DateiPfad = rp.GetSafeDirDefaultExternal("")
#Else If B4J
	xui.SetDataFolder("Strom")
	DateiPfad = xui.DefaultFolder
#End If
	Log(DateiPfad)	'zur Information
	
#If B4J
	Sleep(0)	'ist gebraucht damit die Tabelle richtig angezeigt wird
#End IF

'	File.Delete(DateiPfad, DateiName) 'zum Testen, die original Datenbank wieder herstellen

'Initilisiert die Datenbank
	If File.Exists(DateiPfad, DateiName) = True Then
#If B4A
		SQL1.Initialize(DateiPfad, DateiName, True)
#Else If B4J
		SQL1.InitializeSQLite(DateiPfad, DateiName, True)
#End If
	Else
		'Falls die Datei noch nicht existiert, wird eine Test-Datenbank erstellt
		InitDB
	End If
	
	'setzt das heitige Datum in die edtDatum View
	edtDatum.Text = DateTime.Date(DateTime.Now)
	
	'ladet die Datenbank in die Tabelle
	Query = "SELECT * FROM Zähler"
	tblZaehler.LoadSQLiteDB2(SQL1, Query, True, Array As String("T", "T", "I"))
	
	ComboBoxenFuellen	'füllt die ComboBox für die Zähler
	
	UpdateFilter	'füllt die Filter-ComboBoxen
	
End Sub

Private Sub btnHinzufuegen_Click
	Private Row() As String
	Private NbItems As Int
	
	'testet ob der Eintrag schon existiert
	NbItems = SQL1.ExecQuerySingleResult2("SELECT count() FROM Zähler WHERE ZählerNummer = ? AND Datum = ? AND Zählerstand = ?", Array As String(edtZaehlerNummer.Text, edtDatum.Text, edtZaehlerstand.Text))
	'wenn JA, aufhören
	If NbItems > 0 Then
		xui.MsgboxAsync("Dieser Eintrag existiert schon !", "A C H T U N G")
		Return
	End If
	'wenn NEIN, Eintrag hinzu fügen
	Row = Array As String(edtZaehlerNummer.Text, edtDatum.Text, edtZaehlerstand.Text)
	SQL1.ExecNonQuery2("INSERT INTO Zähler VALUES (?, ?, ?)", Array As Object(edtZaehlerNummer.Text, edtDatum.Text, edtZaehlerstand.Text))
	tblZaehler.AddRow(Row)

	If SelectedRowIndex > -1 Then
		tblZaehler.UnselectRow(SelectedRowIndex)
	End If

	tblZaehler.SelectRow(tblZaehler.NumberOfRows - 1)
	tblZaehler.JumpToRow(tblZaehler.NumberOfRows - 1)
	
	btnAendern.Visible = True
	btnLoeschen.Visible = True
#If B4A
	IME1.HideKeyboard
#End If
End Sub

Private Sub btnAendern_Click
	SQL1.ExecNonQuery2("UPDATE Zähler Set ZählerNummer = ?, Datum = ?, Zählerstand = ? WHERE rowid = ?", Array As Object(edtZaehlerNummer.Text, edtDatum.Text, edtZaehlerstand.Text, SelectedItemRowID))
	tblZaehler.LoadSQLiteDB2(SQL1, Query & Filter, True, Array As String("T", "T", "I"))
#If B4A
	IME1.HideKeyboard
#End If
End Sub

Private Sub btnLoeschen_Click
#If B4A
	Msgbox2Async("Wollen Sie wirklich diesen Eintrag löschen ?", "ACHTUNG", "Ja", "", "Nein", Null, True)
	Wait For Msgbox_Result (Result As Int)
#Else
	Dim sf As Object = xui.Msgbox2Async("Wollen Sie wirklich diesen Eintrag löschen ?", "ACHTUNG", "Ja", "", "Nein", Null)
	Wait For (sf) Msgbox_Result (Result As Int)
#End If
	If Result = xui.DialogResponse_Positive Then
		SQL1.ExecNonQuery("DELETE FROM Zähler WHERE rowid = " & SelectedItemRowID)
		tblZaehler.RemoveRow(SelectedRowIndex)
	End If
End Sub


Private Sub btnEnde_Click
	ExitApplication
End Sub

Private Sub tblZaehler_CellClick(col As Int, row As Int)
	Private Werte() As String
	
'	If SelectedItemRowID = -1 Then
	If row <> SelectedRowIndex Then
		'keine Zeile selektiert, die Zeile wird selektiert
		SelectedRowIndex = row
		Werte = tblZaehler.Data.Get(row)
		edtZaehlerNummer.Text = Werte(0)
		edtDatum.Text = Werte(1)
		edtZaehlerstand.Text = Werte(2)
		SelectedItemRowID = SQL1 .ExecQuerySingleResult("SELECT rowid FROM Zähler WHERE ZählerNummer = '" & edtZaehlerNummer.Text & "' AND Datum = '" & edtDatum.Text & "' AND Zählerstand = " & edtZaehlerstand.Text)
		btnAendern.Visible = True
		btnLoeschen.Visible = True
	Else
		'die Zeile wird abgewählt
		SelectedRowIndex = -1
		SelectedItemRowID = -1
		edtZaehlerNummer.Text = ""
		edtDatum.Text = DateTime.Date(DateTime.Now)
		edtZaehlerstand.Text = ""
		btnAendern.Visible = False
		btnLoeschen.Visible = False
	End If
End Sub

Private Sub ComboBoxenFuellen
	Private Rst As ResultSet
	Private lst As List

	Rst = SQL1.ExecQuery("SELECT DISTINCT ZählerNummer FROM Zähler")
	lst.Initialize
	Do While Rst.NextRow
		lst.Add(Rst.GetString("ZählerNummer"))
	Loop
	cbxZaehlerNummer.SetItems(lst)
	
	lst.InsertAt(0, "Ohne Filter")
	cbxFilterZaehler.SetItems(lst)
	
	Rst = SQL1.ExecQuery("SELECT DISTINCT Datum FROM Zähler")
	lst.Initialize
	lst.Add("Ohne Filter")
	Do While Rst.NextRow
		lst.Add(Rst.GetString("Datum"))
	Loop
	cbxFilterDatum.SetItems(lst)
	
	Rst.Close
End Sub

Private Sub UpdateFilter
	Private lst As List
	Private Rds As ResultSet
	
	Rds = SQL1.ExecQuery("SELECT DISTINCT ZählerNummer FROM Zähler")
	lst.Initialize
	lst.Add("Ohne Filter")
	Do While Rds.NextRow
		lst.Add(Rds.GetString("ZählerNummer"))
	Loop
	cbxFilterZaehler.SetItems(lst)
	
	Rds = SQL1.ExecQuery("SELECT DISTINCT Datum FROM Zähler")
	lst.Initialize
	lst.Add("Ohne Filter")
	Do While Rds.NextRow
		lst.Add(Rds.GetString("Datum"))
	Loop
	cbxFilterDatum.SetItems(lst)
	
	Rds.Close
End Sub

Private Sub cbxZaehlerNummer_SelectedIndexChanged (Index As Int)
	edtZaehlerNummer.Text = cbxZaehlerNummer.SelectedItem
End Sub

Private Sub cbxFilterZaehler_SelectedIndexChanged (Index As Int)
	SetFilter
End Sub

Private Sub cbxFilterDatum_SelectedIndexChanged (Index As Int)
	SetFilter
End Sub

Private Sub SetFilter
	Filter = ""
	If cbxFilterZaehler.SelectedIndex > 0 Then
		Filter = " WHERE ZählerNummer = '" & cbxFilterZaehler.SelectedItem & "'"
	End If
	
	If cbxFilterDatum.SelectedIndex > 0 Then
		If cbxFilterZaehler.SelectedIndex > 0 Then
			Filter = Filter & " AND "
		Else
			Filter = Filter & " WHERE "
		End If
		Filter = Filter & "Datum = '" & cbxFilterDatum.SelectedItem & "'"
	End If
	
	tblZaehler.LoadSQLiteDB2(SQL1, Query & Filter, True, Array As String("T", "T", "I"))
End Sub

Private Sub InitDB
#If B4A
	SQL1.Initialize(DateiPfad, DateiName, True)
#Else If B4J
	SQL1.InitializeSQLite(DateiPfad, DateiName, True)
#End If	
	SQL1.ExecNonQuery("CREATE TABLE Zähler (ZählerNummer TEXT , Datum TEXT, ZählerStand INTEGER)")
	'SQL1.ExecNonQuery2("INSERT INTO Zähler VALUES (?, ?, ?)", Array As Object("12", "2022.12.11", 124))
	'SQL1.ExecNonQuery2("INSERT INTO Zähler VALUES (?, ?, ?)", Array As Object("13", "2022.12.11", 134))
	'SQL1.ExecNonQuery2("INSERT INTO Zähler VALUES (?, ?, ?)", Array As Object("14", "2022.12.11", 144))
	'SQL1.ExecNonQuery2("INSERT INTO Zähler VALUES (?, ?, ?)", Array As Object("15", "2022.12.11", 144))
	'SQL1.ExecNonQuery2("INSERT INTO Zähler VALUES (?, ?, ?)", Array As Object("16", "2022.12.11", 145))
	'SQL1.ExecNonQuery2("INSERT INTO Zähler VALUES (?, ?, ?)", Array As Object("17", "2022.12.11", 147))
	'SQL1.ExecNonQuery2("INSERT INTO Zähler VALUES (?, ?, ?)", Array As Object("18", "2022.12.11", 148))
	'SQL1.ExecNonQuery2("INSERT INTO Zähler VALUES (?, ?, ?)", Array As Object("12", "2022.12.12", 220))
	'SQL1.ExecNonQuery2("INSERT INTO Zähler VALUES (?, ?, ?)", Array As Object("14", "2022.12.12", 254))
	'SQL1.ExecNonQuery2("INSERT INTO Zähler VALUES (?, ?, ?)", Array As Object("17", "2022.12.12", 267))
	'SQL1.ExecNonQuery2("INSERT INTO Zähler VALUES (?, ?, ?)", Array As Object("12", "2022.12.13", 220))
End Sub



Private Sub BtnDisConnect_Click
	
End Sub

Private Sub BtnConnect_Click
	
End Sub

Private Sub BSend_Click
	
End Sub

Private Sub B4XBTDevices_SelectedIndexChanged (Index As Int)
	
End Sub